## x265 4.0

=== source/CMakeLists.txt ===
# vim: syntax=cmake
if(NOT CMAKE_BUILD_TYPE)
    # default to Release build for GCC builds
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()
message(STATUS "cmake version ${CMAKE_VERSION}")
if(POLICY CMP0025)
    cmake_policy(SET CMP0025 OLD) # report Apple's Clang as just Clang
endif()
if(POLICY CMP0042)
    cmake_policy(SET CMP0042 NEW) # MACOSX_RPATH
endif()
if(POLICY CMP0054)
    cmake_policy(SET CMP0054 OLD) # Only interpret if() arguments as variables or keywords when unquoted
endif()

project (x265)
cmake_minimum_required (VERSION 2.8.8) # OBJECT libraries require 2.8.8
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCXXCompilerFlag)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)

option(FPROFILE_GENERATE "Compile executable to generate usage data" OFF)
option(FPROFILE_USE "Compile executable using generated usage data" OFF)
option(NATIVE_BUILD "Target the build CPU" OFF)
option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
# X265_BUILD must be incremented each time the public API is changed
set(X265_BUILD 212)
configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
               "${PROJECT_BINARY_DIR}/x265.def")
configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"
               "${PROJECT_BINARY_DIR}/x265_config.h")

SET(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

# System architecture detection
if (APPLE AND CMAKE_OSX_ARCHITECTURES)
    string(TOLOWER "${CMAKE_OSX_ARCHITECTURES}" SYSPROC)
else()
    string(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" SYSPROC)
endif()
set(X86_ALIASES x86 i386 i686 x86_64 amd64)
set(ARM_ALIASES armv6l armv7l)
set(ARM64_ALIASES arm64 arm64e aarch64)
list(FIND X86_ALIASES "${SYSPROC}" X86MATCH)
list(FIND ARM_ALIASES "${SYSPROC}" ARMMATCH)
list(FIND ARM64_ALIASES "${SYSPROC}" ARM64MATCH)
set(POWER_ALIASES powerpc64 powerpc64le ppc64 ppc64le)
list(FIND POWER_ALIASES "${SYSPROC}" POWERMATCH)
if(X86MATCH GREATER "-1")
    set(X86 1)
    add_definitions(-DX265_ARCH_X86=1)
    if(CMAKE_CXX_FLAGS STREQUAL "-m32")
        message(STATUS "Detected x86 target processor")
    elseif("${CMAKE_SIZEOF_VOID_P}" MATCHES 8)
        set(X64 1)
        add_definitions(-DX86_64=1)
        message(STATUS "Detected x86_64 target processor")
    endif()
elseif(POWERMATCH GREATER "-1")
    message(STATUS "Detected POWER target processor")
    set(POWER 1)
    add_definitions(-DX265_ARCH_POWER=1)
    if("${CMAKE_SIZEOF_VOID_P}" MATCHES 8)
        set(PPC64 1)
        add_definitions(-DPPC64=1)
        message(STATUS "Detected POWER PPC64 target processor")
    endif()
elseif(ARMMATCH GREATER "-1")
    if(CROSS_COMPILE_ARM)
        message(STATUS "Cross compiling for ARM arch")
    else()
        set(CROSS_COMPILE_ARM 0)
    endif()
	message(STATUS "Detected ARM target processor")
    set(ARM 1)
    add_definitions(-DX265_ARCH_ARM=1 -DHAVE_ARMV6=1)
elseif(ARM64MATCH GREATER "-1")
    message(STATUS "Detected ARM64 target processor")
    set(ARM64 1)

    option(AARCH64_WARNINGS_AS_ERRORS "Build with -Werror for AArch64 Intrinsics files" OFF)

    # Options for cross compiling AArch64 optional extensions
    option(CROSS_COMPILE_SVE "Cross Compile for SVE Target" OFF)
    option(CROSS_COMPILE_SVE2 "Cross Compile for SVE2 Target" OFF)
    option(CROSS_COMPILE_NEON_DOTPROD "Cross Compile for Neon DotProd Target" OFF)
    option(CROSS_COMPILE_NEON_I8MM "Cross Compile for Neon I8MM Target" OFF)
else()
    message(STATUS "CMAKE_SYSTEM_PROCESSOR value `${CMAKE_SYSTEM_PROCESSOR}` is unknown")
    message(STATUS "Please add this value near ${CMAKE_CURRENT_LIST_FILE}:${CMAKE_CURRENT_LIST_LINE}")
endif()

if(UNIX)
    list(APPEND PLATFORM_LIBS pthread)
    find_library(LIBRT rt)
    if(LIBRT)
        list(APPEND PLATFORM_LIBS rt)
    endif()
    mark_as_advanced(LIBRT)
    find_library(LIBDL dl)
    if(LIBDL)
        list(APPEND PLATFORM_LIBS dl)
    endif()
    option(ENABLE_LIBNUMA "Enable libnuma usage (Linux only)" ON)
    if(ENABLE_LIBNUMA)
        find_package(Numa)
        if(NUMA_FOUND)
            link_directories(${NUMA_LIBRARY_DIR})
            list(APPEND CMAKE_REQUIRED_LIBRARIES numa)
            list(APPEND CMAKE_REQUIRED_INCLUDES ${NUMA_INCLUDE_DIR})
            list(APPEND CMAKE_REQUIRED_LINK_OPTIONS "-L${NUMA_LIBRARY_DIR}")
            check_symbol_exists(numa_node_of_cpu numa.h NUMA_V2)
            if(NUMA_V2)
                add_definitions(-DHAVE_LIBNUMA)
                message(STATUS "libnuma found, building with support for NUMA nodes")
                list(APPEND PLATFORM_LIBS numa)
                include_directories(${NUMA_INCLUDE_DIR})
            endif()
        endif()
        mark_as_advanced(NUMA_FOUND)
    endif(ENABLE_LIBNUMA)
    option(NO_ATOMICS "Use a slow mutex to replace atomics" OFF)
    if(NO_ATOMICS)
        add_definitions(-DNO_ATOMICS=1)
    endif(NO_ATOMICS)
    find_library(VMAF vmaf)
    option(ENABLE_LIBVMAF "Enable VMAF" OFF)
    if(ENABLE_LIBVMAF)
        add_definitions(-DENABLE_LIBVMAF)
    endif()
endif(UNIX)

if(X64 AND NOT WIN32)
    option(ENABLE_PIC "Enable Position Independent Code" ON)
else()
    option(ENABLE_PIC "Enable Position Independent Code" OFF)
endif(X64 AND NOT WIN32)

# Compiler detection
if(CMAKE_GENERATOR STREQUAL "Xcode")
  set(XCODE 1)
endif()
if(APPLE)
  add_definitions(-DMACOS=1)
endif()

if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CLANG 1)
endif()
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Intel")
    set(INTEL_CXX 1)
endif()
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    set(GCC 1)
endif()

if(INTEL_CXX AND WIN32)
    # treat icl roughly like MSVC
    set(MSVC 1)
endif()
if(MSVC)
    if(STATIC_LINK_CRT)
        set(CompilerFlags CMAKE_CXX_FLAGS_RELEASE CMAKE_C_FLAGS_RELEASE)
        foreach(CompilerFlag ${CompilerFlags})
            string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
        endforeach()
    endif(STATIC_LINK_CRT)
    add_definitions(/W4)  # Full warnings
    add_definitions(/Ob2) # always inline
    add_definitions(/MP)  # multithreaded build

    # disable Microsofts suggestions for proprietary secure APIs
    add_definitions(/D_CRT_SECURE_NO_WARNINGS)

    check_include_files(stdint.h HAVE_STDINT_H)
    if(NOT HAVE_STDINT_H)
        include_directories(compat/msvc)
    endif()
endif(MSVC)

check_include_files(inttypes.h HAVE_INT_TYPES_H)
if(HAVE_INT_TYPES_H)
    add_definitions(-DHAVE_INT_TYPES_H=1)
endif()

if(INTEL_CXX AND UNIX)
    set(GCC 1) # treat icpc roughly like gcc
elseif(CLANG)
    set(GCC 1) # treat clang roughly like gcc
elseif(CMAKE_COMPILER_IS_GNUCXX)
    set(GCC 1)
endif()

if(CC STREQUAL "xlc")
    message(STATUS "Use XLC compiler")
    set(XLC 1)
    set(GCC 0)
    #set(CMAKE_C_COMPILER "/usr/bin/xlc")
    #set(CMAKE_CXX_COMPILER "/usr/bin/xlc++")
    add_definitions(-D__XLC__=1)
    add_definitions(-O3 -qstrict -qhot -qaltivec)
    add_definitions(-qinline=level=10 -qpath=IL:/data/video_files/latest.tpo/)
endif()
# this option is to enable the inclusion of dynamic HDR10 library to the libx265 compilation
option(ENABLE_HDR10_PLUS "Enable dynamic HDR10 compilation" OFF)
if(MSVC AND (MSVC_VERSION LESS 1800) AND ENABLE_HDR10_PLUS)
    message(FATAL_ERROR "MSVC version 12.0 or above required to support hdr10plus")
endif()
if(WIN32 AND (MSVC_VERSION GREATER 1800))
    if(CMAKE_VERSION VERSION_LESS 3.7)
        message(FATAL_ERROR "cmake version not compatible for VS 2017. Update the cmake to versions 3.7 or above")
    endif()
endif()
if(GCC)
    add_definitions(-Wall -Wextra -Wshadow)
    add_definitions(-D__STDC_LIMIT_MACROS=1)
    if(NOT INTEL_CXX AND NOT CLANG AND CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 8.0)
        add_definitions(-Wno-class-memaccess)
    endif()
    if(ENABLE_HDR10_PLUS)
        if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.8")
            message(FATAL_ERROR "gcc version above 4.8 required to support hdr10plus")
        endif()
        add_definitions(-std=gnu++11)
    else()
        add_definitions(-std=gnu++98)
    endif()
    if(ENABLE_PIC)
         add_definitions(-fPIC)
    endif(ENABLE_PIC)
    if(NATIVE_BUILD)
        if(INTEL_CXX)
            add_definitions(-xhost)
        else()
            add_definitions(-march=native)
        endif()
    elseif(X86 AND NOT X64)
        string(FIND "${CMAKE_CXX_FLAGS}" "-march" marchPos)
        if(marchPos LESS "0")
            add_definitions(-march=i686)
            if(WIN32 AND NOT INTEL_CXX AND NOT CLANG AND
               CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 6.0 AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0)
                add_definitions(-mpreferred-stack-boundary=2)
            endif()
        endif()
    endif()
    if(ARM AND CROSS_COMPILE_ARM)
        message(STATUS "cross compile arm")
		set(ARM_ARGS -march=armv6 -mfloat-abi=soft -mfpu=vfp -marm -fPIC)
    elseif(ARM)
        find_package(Neon)
        if(CPU_HAS_NEON)
            set(ARM_ARGS -mcpu=native -mfloat-abi=hard -mfpu=neon -marm -fPIC)
            add_definitions(-DHAVE_NEON)
        else()
            set(ARM_ARGS -mcpu=native -mfloat-abi=hard -mfpu=vfp -marm)
        endif()
    endif()
    if(ARM64)
        message(STATUS "Found Neon")
        set(CPU_HAS_NEON 1)
        add_definitions(-DX265_ARCH_ARM64=1 -DHAVE_NEON=1)

        if(CROSS_COMPILE_ARM64)
            # Handle cross-compilation options.
            if(CROSS_COMPILE_NEON_DOTPROD)
                set(CPU_HAS_NEON_DOTPROD 1)
            endif()
            if(CROSS_COMPILE_NEON_I8MM)
                set(CPU_HAS_NEON_I8MM 1)
                # Impose the constraint that Neon I8MM implies Neon DotProd.
                set(CPU_HAS_NEON_DOTPROD 1)
            endif()
            if(CROSS_COMPILE_SVE)
                set(CPU_HAS_SVE 1)
                # Impose the constraint that SVE implies Neon DotProd and I8MM.
                set(CPU_HAS_NEON_DOTPROD 1)
                set(CPU_HAS_NEON_I8MM 1)
            endif()
            if(CROSS_COMPILE_SVE2)
                set(CPU_HAS_SVE2 1)
                # SVE2 implies SVE and Neon DotProd.
                set(CPU_HAS_SVE 1)
                set(CPU_HAS_NEON_DOTPROD 1)
                # Impose the constraint that SVE2 implies Neon I8MM.
                set(CPU_HAS_NEON_I8MM 1)
            endif()
        else()
            if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
                find_package(NEON_DOTPROD)
                find_package(NEON_I8MM)
                find_package(SVE)
                find_package(SVE2)
            else()
                message(STATUS "Compile time feature detection unsupported on this platform")
            endif()
        endif()

        if(CPU_HAS_NEON_DOTPROD)
            # Neon DotProd is mandatory from Armv8.4.
            message(STATUS "Found Neon DotProd")
            set(ARM_ARGS -O3 -march=armv8.2-a+dotprod)
            add_definitions(-DHAVE_NEON_DOTPROD=1)
        endif()
        if(CPU_HAS_NEON_I8MM)
            # Neon I8MM is mandatory from Armv8.6.
            message(STATUS "Found Neon I8MM")
            # Impose the constraint that Neon I8MM implies Neon DotProd.
            if(NOT CPU_HAS_NEON_DOTPROD)
                message(FATAL_ERROR "Unsupported AArch64 feature combination (Neon I8MM without Neon DotProd)")
            endif()
            set(ARM_ARGS -O3 -march=armv8.2-a+dotprod+i8mm)
            add_definitions(-DHAVE_NEON_I8MM=1)
        endif()
        if(CPU_HAS_SVE)
            message(STATUS "Found SVE")
            # Impose the constraint that SVE implies Neon I8MM.
            if(NOT CPU_HAS_NEON_I8MM)
                message(FATAL_ERROR "Unsupported AArch64 feature combination (SVE without Neon I8MM)")
            endif()
            set(ARM_ARGS -O3 -march=armv8.2-a+dotprod+i8mm+sve)

=== source/common/CMakeLists.txt ===
# vim: syntax=cmake

list(APPEND VFLAGS "-DX265_VERSION=${X265_VERSION}")
if(EXTRA_LIB)
    if(LINKED_8BIT)
        list(APPEND VFLAGS "-DLINKED_8BIT=1")
    endif(LINKED_8BIT)
    if(LINKED_10BIT)
        list(APPEND VFLAGS "-DLINKED_10BIT=1")
    endif(LINKED_10BIT)
    if(LINKED_12BIT)
        list(APPEND VFLAGS "-DLINKED_12BIT=1")
    endif(LINKED_12BIT)
endif(EXTRA_LIB)

if(ENABLE_ASSEMBLY)
    set_source_files_properties(threading.cpp primitives.cpp pixel.cpp PROPERTIES COMPILE_FLAGS -DENABLE_ASSEMBLY=1)
    list(APPEND VFLAGS "-DENABLE_ASSEMBLY=1")
endif(ENABLE_ASSEMBLY)

if(ENABLE_ASSEMBLY AND X86)
    set(SSE3  vec/dct-sse3.cpp)
    set(SSSE3 vec/dct-ssse3.cpp)
    set(SSE41 vec/dct-sse41.cpp)

    if(MSVC)
        set(PRIMITIVES ${SSE3} ${SSSE3} ${SSE41})
        set(WARNDISABLE "/wd4100") # unreferenced formal parameter
        if(INTEL_CXX)
            add_definitions(/Qwd111) # statement is unreachable
            add_definitions(/Qwd128) # loop is unreachable
            add_definitions(/Qwd177) # declared function is unused
            add_definitions(/Qwd185) # dynamic initialization in unreachable code
            add_definitions(/Qwd280) # conditional expression is constant
        endif()
        if(X64)
            set_source_files_properties(${SSE3} ${SSSE3} ${SSE41} PROPERTIES COMPILE_FLAGS "${WARNDISABLE}")
        else()
            # x64 implies SSE4, so only add /arch:SSE2 if building for Win32
            set_source_files_properties(${SSE3} ${SSSE3} ${SSE41} PROPERTIES COMPILE_FLAGS "${WARNDISABLE} /arch:SSE2")
        endif()
    endif()
    if(GCC)
        if(CLANG)
            # llvm intrinsic headers cause shadow warnings
            set(WARNDISABLE "-Wno-shadow -Wno-unused-parameter")
        else()
            set(WARNDISABLE "-Wno-unused-parameter")
        endif()
        if(INTEL_CXX OR CLANG OR (NOT CC_VERSION VERSION_LESS 4.3))
            set(PRIMITIVES ${SSE3} ${SSSE3} ${SSE41})
            set_source_files_properties(${SSE3}  PROPERTIES COMPILE_FLAGS "${WARNDISABLE} -msse3")
            set_source_files_properties(${SSSE3} PROPERTIES COMPILE_FLAGS "${WARNDISABLE} -mssse3")
            set_source_files_properties(${SSE41} PROPERTIES COMPILE_FLAGS "${WARNDISABLE} -msse4.1")
        endif()
    endif()
    set(VEC_PRIMITIVES vec/vec-primitives.cpp ${PRIMITIVES})
    source_group(Intrinsics FILES ${VEC_PRIMITIVES})
    set(C_SRCS asm-primitives.cpp pixel.h mc.h ipfilter8.h blockcopy8.h dct8.h loopfilter.h seaintegral.h)
    set(A_SRCS pixel-a.asm const-a.asm cpu-a.asm ssd-a.asm mc-a.asm
               mc-a2.asm pixel-util8.asm blockcopy8.asm
               pixeladd8.asm dct8.asm seaintegral.asm)
    if(HIGH_BIT_DEPTH)
        set(A_SRCS ${A_SRCS} sad16-a.asm intrapred16.asm v4-ipfilter16.asm h4-ipfilter16.asm h-ipfilter16.asm ipfilter16.asm loopfilter.asm)
    else()
        set(A_SRCS ${A_SRCS} sad-a.asm intrapred8.asm intrapred8_allangs.asm v4-ipfilter8.asm h-ipfilter8.asm ipfilter8.asm loopfilter.asm)
    endif()
    if(NOT X64)
        set(A_SRCS ${A_SRCS} pixel-32.asm)
    endif()

    if(MSVC_IDE OR XCODE)
        # MSVC requires custom build rules in the main cmake script for nasm
        set(MSVC_ASMS "${A_SRCS}" CACHE INTERNAL "nasm sources")
        set(A_SRCS)
    endif()

    enable_language(ASM_NASM)

    foreach(SRC ${A_SRCS} ${C_SRCS})
        set(ASM_PRIMITIVES ${ASM_PRIMITIVES} x86/${SRC})
    endforeach()
    source_group(Assembly FILES ${ASM_PRIMITIVES})
endif(ENABLE_ASSEMBLY AND X86)

if(ENABLE_ASSEMBLY AND (ARM OR CROSS_COMPILE_ARM))
    set(C_SRCS asm-primitives.cpp pixel.h mc.h ipfilter8.h blockcopy8.h dct8.h loopfilter.h)

    # add ARM assembly/intrinsic files here
    set(A_SRCS asm.S cpu-a.S mc-a.S sad-a.S pixel-util.S ssd-a.S blockcopy8.S ipfilter8.S dct-a.S)
    set(VEC_PRIMITIVES)

    set(ARM_ASMS "${A_SRCS}" CACHE INTERNAL "ARM Assembly Sources")
    foreach(SRC ${C_SRCS})
        set(ASM_PRIMITIVES ${ASM_PRIMITIVES} arm/${SRC})
    endforeach()
    source_group(Assembly FILES ${ASM_PRIMITIVES})
endif(ENABLE_ASSEMBLY AND (ARM OR CROSS_COMPILE_ARM))

if(ENABLE_ASSEMBLY AND (ARM64 OR CROSS_COMPILE_ARM64))
    if(GCC AND (CMAKE_CXX_FLAGS_RELEASE MATCHES "-O3"))
        message(STATUS "Detected CXX compiler using -O3 optimization level")
        add_definitions(-DAUTO_VECTORIZE=1)
    endif()

    set(C_SRCS_NEON asm-primitives.cpp pixel-prim.h pixel-prim.cpp filter-prim.h filter-prim.cpp dct-prim.h dct-prim.cpp loopfilter-prim.cpp loopfilter-prim.h intrapred-prim.cpp arm64-utils.cpp arm64-utils.h fun-decls.h sao-prim.cpp  mem-neon.h)
    set(C_SRCS_NEON_DOTPROD filter-neon-dotprod.cpp)
    set(C_SRCS_NEON_I8MM filter-neon-i8mm.cpp)
    set(C_SRCS_SVE sao-prim-sve.cpp dct-prim-sve.cpp)
    set(C_SRCS_SVE2 sao-prim-sve2.cpp)
    enable_language(ASM)

    # add ARM assembly/intrinsic files here
    set(A_SRCS asm.S mc-a.S mc-a-common.S sad-a.S pixel-util.S pixel-util-common.S p2s.S p2s-common.S blockcopy8.S blockcopy8-common.S ssd-a.S ssd-a-common.S intrapred.S dct.S)
    set(A_SRCS_SVE asm-sve.S blockcopy8-sve.S p2s-sve.S pixel-util-sve.S)
    set(A_SRCS_SVE2 mc-a-sve2.S pixel-util-sve2.S ssd-a-sve2.S)
    set(A_SRCS_NEON_DOTPROD sad-neon-dotprod.S ssd-neon-dotprod.S)
    set(VEC_PRIMITIVES)

    set(ARM_ASMS "${A_SRCS}" CACHE INTERNAL "ARM Assembly Sources")
    set(ARM_ASMS_SVE "${A_SRCS_SVE}" CACHE INTERNAL "ARM Assembly Sources that use SVE instruction set")
    set(ARM_ASMS_SVE2 "${A_SRCS_SVE2}" CACHE INTERNAL "ARM Assembly Sources that use SVE2 instruction set")
    set(ARM_ASMS_NEON_DOTPROD "${A_SRCS_NEON_DOTPROD}" CACHE INTERNAL "Arm Assembly Sources that use the Neon DotProd extension")
    foreach(SRC ${C_SRCS_NEON})
        set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
    endforeach()

    if(CPU_HAS_NEON_I8MM)
        foreach(SRC ${C_SRCS_NEON_I8MM})
            set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
        endforeach()
    endif()

    if(CPU_HAS_NEON_DOTPROD)
        foreach(SRC ${C_SRCS_NEON_DOTPROD})
            set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
        endforeach()
    endif()

    if(CPU_HAS_SVE AND HAVE_SVE_BRIDGE)
        foreach(SRC ${C_SRCS_SVE})
            set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
        endforeach()
    endif()

    if(CPU_HAS_SVE2 AND HAVE_SVE_BRIDGE)
        foreach(SRC ${C_SRCS_SVE2})
            set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
        endforeach()
    endif()

    source_group(Assembly FILES ${ASM_PRIMITIVES})

    if(AARCH64_WARNINGS_AS_ERRORS)
        set_source_files_properties(${ASM_PRIMITIVES} PROPERTIES COMPILE_FLAGS -Werror)
    endif()
endif(ENABLE_ASSEMBLY AND (ARM64 OR CROSS_COMPILE_ARM64))

if(POWER)
    set_source_files_properties(version.cpp PROPERTIES COMPILE_FLAGS -DX265_VERSION=${X265_VERSION})
    if(ENABLE_ALTIVEC)
        set(ALTIVEC_SRCS pixel_altivec.cpp dct_altivec.cpp ipfilter_altivec.cpp intrapred_altivec.cpp)
        foreach(SRC ${ALTIVEC_SRCS})
            set(ALTIVEC_PRIMITIVES ${ALTIVEC_PRIMITIVES} ppc/${SRC})
        endforeach()
        source_group(Intrinsics_altivec FILES ${ALTIVEC_PRIMITIVES})
        set_source_files_properties(${ALTIVEC_PRIMITIVES} PROPERTIES COMPILE_FLAGS "-Wno-unused  -Wno-unknown-pragmas -Wno-maybe-uninitialized")
    endif()
endif()


# set_target_properties can't do list expansion
string(REPLACE ";" " " VERSION_FLAGS "${VFLAGS}")
set_source_files_properties(version.cpp PROPERTIES COMPILE_FLAGS ${VERSION_FLAGS})

check_symbol_exists(strtok_r "string.h" HAVE_STRTOK_R)
if(HAVE_STRTOK_R)
    set_source_files_properties(param.cpp PROPERTIES COMPILE_FLAGS -DHAVE_STRTOK_R=1)
endif()

if(GCC AND CC_HAS_NO_NARROWING)
    set_source_files_properties(cpu.cpp PROPERTIES COMPILE_FLAGS -Wno-narrowing)
endif()
if(WIN32)
    set(WINXP winxp.h winxp.cpp)
endif(WIN32)

add_library(common OBJECT
    ${ASM_PRIMITIVES} ${VEC_PRIMITIVES} ${ALTIVEC_PRIMITIVES} ${WINXP}
    primitives.cpp primitives.h
    pixel.cpp dct.cpp lowpassdct.cpp ipfilter.cpp intrapred.cpp loopfilter.cpp
    constants.cpp constants.h
    cpu.cpp cpu.h version.cpp
    threading.cpp threading.h
    threadpool.cpp threadpool.h
    wavefront.h wavefront.cpp
    md5.cpp md5.h
    bitstream.h bitstream.cpp
    yuv.cpp yuv.h
    shortyuv.cpp shortyuv.h
    picyuv.cpp picyuv.h
    common.cpp common.h
    param.cpp param.h
    frame.cpp frame.h
    framedata.cpp framedata.h
    cudata.cpp cudata.h
    slice.cpp slice.h
    lowres.cpp lowres.h mv.h 
    piclist.cpp piclist.h
    predict.cpp  predict.h
    scalinglist.cpp scalinglist.h
    quant.cpp quant.h contexts.h
    deblock.cpp deblock.h
    scaler.cpp scaler.h
    ringmem.cpp ringmem.h
    temporalfilter.cpp temporalfilter.h)

## x265 4.1

=== doc/requirements.txt ===
sphinx
sphinx-rtd-theme
# Add other dependencies here

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -28,10 +28,10 @@
 option(FPROFILE_GENERATE "Compile executable to generate usage data" OFF)
 option(FPROFILE_USE "Compile executable using generated usage data" OFF)
 option(NATIVE_BUILD "Target the build CPU" OFF)
-option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
+option(STATIC_LINK_CRT "Statically link C and C++ runtimes for release builds" OFF)
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 212)
+set(X265_BUILD 215)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"
@@ -87,11 +87,28 @@
 
     option(AARCH64_WARNINGS_AS_ERRORS "Build with -Werror for AArch64 Intrinsics files" OFF)
 
-    # Options for cross compiling AArch64 optional extensions
-    option(CROSS_COMPILE_SVE "Cross Compile for SVE Target" OFF)
-    option(CROSS_COMPILE_SVE2 "Cross Compile for SVE2 Target" OFF)
-    option(CROSS_COMPILE_NEON_DOTPROD "Cross Compile for Neon DotProd Target" OFF)
-    option(CROSS_COMPILE_NEON_I8MM "Cross Compile for Neon I8MM Target" OFF)
+    option(AARCH64_RUNTIME_CPU_DETECT "Enable AArch64 run-time CPU feature detection" ON)
+    if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin|Windows")
+        set(AARCH64_RUNTIME_CPU_DETECT OFF CACHE BOOL "" FORCE)
+        message(STATUS "Run-time CPU feature detection unsupported on this platform")
+    endif()
+
+    # Options for manually enabling/disabling AArch64 SIMD extensions.
+    option(ENABLE_NEON "Enable Neon" ON)
+    option(ENABLE_NEON_DOTPROD "Enable Neon DotProd" ON)
+    option(ENABLE_NEON_I8MM "Enable Neon I8MM" ON)
+    option(ENABLE_SVE "Enable SVE" ON)
+    option(ENABLE_SVE2 "Enable SVE2" ON)
+
+    # Compiler flags for AArch64 extensions.
+    set(AARCH64_NEON_FLAG "-march=armv8-a")
+    # Neon DotProd is mandatory from Armv8.4.
+    set(AARCH64_NEON_DOTPROD_FLAG "-march=armv8.2-a+dotprod")
+    # Neon I8MM is mandatory from Armv8.6.
+    set(AARCH64_NEON_I8MM_FLAG "-march=armv8.2-a+dotprod+i8mm")
+    set(AARCH64_SVE_FLAG "-march=armv8.2-a+dotprod+i8mm+sve")
+    # SVE2 is only available from Armv9.0, and armv9-a implies +dotprod and +sve.
+    set(AARCH64_SVE2_FLAG "-march=armv9-a+i8mm+sve2")
 else()
     message(STATUS "CMAKE_SYSTEM_PROCESSOR value `${CMAKE_SYSTEM_PROCESSOR}` is unknown")
     message(STATUS "Please add this value near ${CMAKE_CURRENT_LIST_FILE}:${CMAKE_CURRENT_LIST_LINE}")
@@ -137,11 +154,11 @@
     endif()
 endif(UNIX)
 
-if(X64 AND NOT WIN32)
+if((X64 AND NOT WIN32) OR ARM64)
     option(ENABLE_PIC "Enable Position Independent Code" ON)
 else()
     option(ENABLE_PIC "Enable Position Independent Code" OFF)
-endif(X64 AND NOT WIN32)
+endif()
 
 # Compiler detection
 if(CMAKE_GENERATOR STREQUAL "Xcode")
@@ -264,34 +281,20 @@
         endif()
     endif()
     if(ARM64)
-        message(STATUS "Found Neon")
         set(CPU_HAS_NEON 1)
-        add_definitions(-DX265_ARCH_ARM64=1 -DHAVE_NEON=1)
-
-        if(CROSS_COMPILE_ARM64)
-            # Handle cross-compilation options.
-            if(CROSS_COMPILE_NEON_DOTPROD)
-                set(CPU_HAS_NEON_DOTPROD 1)
-            endif()
-            if(CROSS_COMPILE_NEON_I8MM)
-                set(CPU_HAS_NEON_I8MM 1)
-                # Impose the constraint that Neon I8MM implies Neon DotProd.
-                set(CPU_HAS_NEON_DOTPROD 1)
-            endif()
-            if(CROSS_COMPILE_SVE)
-                set(CPU_HAS_SVE 1)
-                # Impose the constraint that SVE implies Neon DotProd and I8MM.
-                set(CPU_HAS_NEON_DOTPROD 1)
-                set(CPU_HAS_NEON_I8MM 1)
-            endif()
-            if(CROSS_COMPILE_SVE2)
-                set(CPU_HAS_SVE2 1)
-                # SVE2 implies SVE and Neon DotProd.
-                set(CPU_HAS_SVE 1)
-                set(CPU_HAS_NEON_DOTPROD 1)
-                # Impose the constraint that SVE2 implies Neon I8MM.
-                set(CPU_HAS_NEON_I8MM 1)
-            endif()
+        add_definitions(-DX265_ARCH_ARM64=1)
+
+        if (AARCH64_RUNTIME_CPU_DETECT)
+            add_definitions(-DAARCH64_RUNTIME_CPU_DETECT=1)
+            message(STATUS "Configuring build for run-time CPU feature detection")
+        endif()
+
+        if(AARCH64_RUNTIME_CPU_DETECT OR CROSS_COMPILE_ARM64)
+            # Add all extensions when compiling for run-time CPU feature detection or cross compiling.
+            set(CPU_HAS_NEON_DOTPROD 1)
+            set(CPU_HAS_NEON_I8MM 1)
+            set(CPU_HAS_SVE 1)
+            set(CPU_HAS_SVE2 1)
         else()
             if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
                 find_package(NEON_DOTPROD)
@@ -299,30 +302,28 @@
                 find_package(SVE)
                 find_package(SVE2)
             else()
-                message(STATUS "Compile time feature detection unsupported on this platform")
+                message(STATUS "Compile-time CPU feature detection unsupported on this platform")
             endif()
         endif()
 
-        if(CPU_HAS_NEON_DOTPROD)
-            # Neon DotProd is mandatory from Armv8.4.
-            message(STATUS "Found Neon DotProd")
-            set(ARM_ARGS -O3 -march=armv8.2-a+dotprod)
-            add_definitions(-DHAVE_NEON_DOTPROD=1)
-        endif()
-        if(CPU_HAS_NEON_I8MM)
-            # Neon I8MM is mandatory from Armv8.6.
-            message(STATUS "Found Neon I8MM")
-            # Impose the constraint that Neon I8MM implies Neon DotProd.
-            if(NOT CPU_HAS_NEON_DOTPROD)
-                message(FATAL_ERROR "Unsupported AArch64 feature combination (Neon I8MM without Neon DotProd)")
-            endif()
-            set(ARM_ARGS -O3 -march=armv8.2-a+dotprod+i8mm)
-            add_definitions(-DHAVE_NEON_I8MM=1)
-        endif()
-        if(CPU_HAS_SVE)
-            message(STATUS "Found SVE")
-            # Impose the constraint that SVE implies Neon I8MM.
-            if(NOT CPU_HAS_NEON_I8MM)
-                message(FATAL_ERROR "Unsupported AArch64 feature combination (SVE without Neon I8MM)")
-            endif()
-            set(ARM_ARGS -O3 -march=armv8.2-a+dotprod+i8mm+sve)
+        if(ENABLE_SVE OR ENABLE_SVE2)
+            set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
+            string(APPEND CMAKE_REQUIRED_FLAGS " ${AARCH64_SVE_FLAG}")
+            set(OLD_CMAKE_TRY_COMPILE_TARGET_TYPE ${CMAKE_TRY_COMPILE_TARGET_TYPE})
+            set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
+
+            # Check whether the compiler can compile SVE functions that require
+            # backup/restore of SVE registers according to AAPCS.
+            # https://github.com/llvm/llvm-project/issues/80009.
+            set(SVE_COMPILATION_TEST "
+#include <arm_sve.h>
+void other();
+svfloat32_t func(svfloat32_t a) {
+  other();
+  return a;
+}
+int main() { return 0; }")
+
+            check_c_source_compiles("${SVE_COMPILATION_TEST}" SVE_COMPILATION_C_TEST_COMPILED)
+            check_cxx_source_compiles("${SVE_COMPILATION_TEST}" SVE_COMPILATION_CXX_TEST_COMPILED)
+

=== source/common/CMakeLists.txt ===
--- 
+++ 
@@ -103,6 +103,7 @@
         add_definitions(-DAUTO_VECTORIZE=1)
     endif()
 
+    # Add Arm intrinsics files here.
     set(C_SRCS_NEON asm-primitives.cpp pixel-prim.h pixel-prim.cpp filter-prim.h filter-prim.cpp dct-prim.h dct-prim.cpp loopfilter-prim.cpp loopfilter-prim.h intrapred-prim.cpp arm64-utils.cpp arm64-utils.h fun-decls.h sao-prim.cpp  mem-neon.h)
     set(C_SRCS_NEON_DOTPROD filter-neon-dotprod.cpp)
     set(C_SRCS_NEON_I8MM filter-neon-i8mm.cpp)
@@ -110,11 +111,11 @@
     set(C_SRCS_SVE2 sao-prim-sve2.cpp)
     enable_language(ASM)
 
-    # add ARM assembly/intrinsic files here
+    # Add Arm assembly files here.
     set(A_SRCS asm.S mc-a.S mc-a-common.S sad-a.S pixel-util.S pixel-util-common.S p2s.S p2s-common.S blockcopy8.S blockcopy8-common.S ssd-a.S ssd-a-common.S intrapred.S dct.S)
+    set(A_SRCS_NEON_DOTPROD sad-neon-dotprod.S ssd-neon-dotprod.S)
     set(A_SRCS_SVE asm-sve.S blockcopy8-sve.S p2s-sve.S pixel-util-sve.S)
     set(A_SRCS_SVE2 mc-a-sve2.S pixel-util-sve2.S ssd-a-sve2.S)
-    set(A_SRCS_NEON_DOTPROD sad-neon-dotprod.S ssd-neon-dotprod.S)
     set(VEC_PRIMITIVES)
 
     set(ARM_ASMS "${A_SRCS}" CACHE INTERNAL "ARM Assembly Sources")
@@ -123,29 +124,34 @@
     set(ARM_ASMS_NEON_DOTPROD "${A_SRCS_NEON_DOTPROD}" CACHE INTERNAL "Arm Assembly Sources that use the Neon DotProd extension")
     foreach(SRC ${C_SRCS_NEON})
         set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
+        set_source_files_properties(aarch64/${SRC} PROPERTIES COMPILE_FLAGS ${AARCH64_NEON_FLAG})
     endforeach()
+
+    if(CPU_HAS_NEON_DOTPROD)
+        foreach(SRC ${C_SRCS_NEON_DOTPROD})
+            set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
+            set_source_files_properties(aarch64/${SRC} PROPERTIES COMPILE_FLAGS ${AARCH64_NEON_DOTPROD_FLAG})
+        endforeach()
+    endif()
 
     if(CPU_HAS_NEON_I8MM)
         foreach(SRC ${C_SRCS_NEON_I8MM})
             set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
-        endforeach()
-    endif()
-
-    if(CPU_HAS_NEON_DOTPROD)
-        foreach(SRC ${C_SRCS_NEON_DOTPROD})
-            set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
+            set_source_files_properties(aarch64/${SRC} PROPERTIES COMPILE_FLAGS ${AARCH64_NEON_I8MM_FLAG})
         endforeach()
     endif()
 
     if(CPU_HAS_SVE AND HAVE_SVE_BRIDGE)
         foreach(SRC ${C_SRCS_SVE})
             set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
+            set_source_files_properties(aarch64/${SRC} PROPERTIES COMPILE_FLAGS ${AARCH64_SVE_FLAG})
         endforeach()
     endif()
 
     if(CPU_HAS_SVE2 AND HAVE_SVE_BRIDGE)
         foreach(SRC ${C_SRCS_SVE2})
             set(ASM_PRIMITIVES ${ASM_PRIMITIVES} aarch64/${SRC})
+            set_source_files_properties(aarch64/${SRC} PROPERTIES COMPILE_FLAGS ${AARCH64_SVE2_FLAG})
         endforeach()
     endif()

=== source/profile/PPA/CMakeLists.txt ===
add_library(PPA ppa.h ppaApi.h ppa.cpp ../cpuEvents.h)

=== debian/changelog ===
x265 (4.1-3) unstable; urgency=medium

  * debian/control:
   - Bump Standards-Version
   - Remove mips* handling
  * debian/patches: Fix FTBFS with cmake 4 (Closes: #1113635)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 26 Sep 2025 10:59:30 +0200

x265 (4.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 22 Jan 2025 01:55:30 +0100

x265 (4.1-1) experimental; urgency=medium

  * New upstream version 4.1
  * SONAME bump: libx265-209 -> libx256-215
  * debian/patches: Refresh patches
  * debian/copyright: Update copyright years
  * debian/control: Add python3-sphinx-rtd-theme to Build-Depends-Indep

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 15 Jan 2025 21:28:29 +0100

=== debian/control ===
Source: x265
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Sebastian Ramacher <sramacher@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 git,
 libnuma-dev [amd64 arm64 i386 powerpc ppc64el],
 nasm [amd64],
 ninja-build
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
 python3-sphinx,
 python3-sphinx-rtd-theme
Standards-Version: 4.7.2
Homepage: https://bitbucket.org/multicoreware/x265_git
Vcs-Git: https://salsa.debian.org/multimedia-team/x265.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/x265
Rules-Requires-Root: no

Package: x265
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: H.265/HEVC video stream encoder
 x265 is a commandline encoder for creating H.265/High Efficiency Video Coding
 (HEVC) video streams.
 .
 x265 supports the following features:
  * full prediction and transform quad-tree recursion supported
  * adaptive B-frame placement
  * B-frames as references / arbitrary frame order
  * CABAC (context-based adaptive binary arithmetic coding) entropy coding
  * supports all Intra block types
  * supports all Inter P partitions
  * supports all Inter B partitions from 64x64 down to 8x4
  * weighted prediction for P slices
  * multiple reference frames
  * scenecut detection
  * parallel encoding on multiple CPUs

Package: libx265-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libx265-215 (= ${binary:Version})
Suggests:
 libx265-doc
Description: H.265/HEVC video stream encoder (development files)
 libx265 is an encoding library for creating H.265/High Efficiency Video Coding
 (HEVC) video streams.
 .
 This is the development package which contains headers and libraries for
 libx265.

Package: libx265-215
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: H.265/HEVC video stream encoder (shared library)
 libx265 is an encoding library for creating H.265/High Efficiency Video Coding
 (HEVC) video streams.
 .
 This package contains the shared library.

Package: libx265-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends}
Description: H.265/HEVC video stream encoder (documentation)
 libx265 is an encoding library for creating H.265/High Efficiency Video Coding
 (HEVC) video streams.
 .
 This package contains documentation for the command line encoder and the
 shared library.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed \
	-L$(CURDIR)/x265-10bit \
	-L$(CURDIR)/x265-12bit
# see #789111
export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions
# LFS support
export DEB_CPPFLAGS_MAINT_APPEND=$(shell getconf LFS_CFLAGS)

FLAGS  = -DENABLE_PIC=ON
# no shared libs are built if HDR10+ is enabled
# FLAGS += -DENABLE_HDR10_PLUS=ON
FLAGS_OTHERBIT  = -DENABLE_CLI=OFF
FLAGS_OTHERBIT += -DENABLE_SHARED=OFF
FLAGS_OTHERBIT += -DEXPORT_C_API=OFF
FLAGS_OTHERBIT += -DHIGH_BIT_DEPTH=ON

# enable assembly builds on amd64 and arm64
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64))
FLAGS += -DENABLE_ASSEMBLY=ON
else
FLAGS += -DENABLE_ASSEMBLY=OFF
endif

# disable altivec on ppc64 (see #923650)
ifneq (,$(filter $(DEB_HOST_ARCH),ppc64))
FLAGS += -DENABLE_ALTIVEC=OFF -DCPU_POWER8=OFF
endif
# disable altivec on ppc64el if building 10 bit and 12 bit versions
# see https://bitbucket.org/multicoreware/x265/issues/320/fail-to-build-on-power8-le
ifneq (,$(filter $(DEB_HOST_ARCH),ppc64el))
FLAGS_OTHERBIT += -DENABLE_ALTIVEC=OFF
endif

%:
	dh $@ --buildsystem=cmake+ninja \
		--sourcedirectory=source \
		--builddirectory=x265-8bit

override_dh_auto_clean:
	dh_auto_clean --builddirectory=x265-10bit
	dh_auto_clean --builddirectory=x265-12bit
	dh_auto_clean
	rm -rf doc/reST/build

# -arch bits

override_dh_auto_configure-arch:
	dh_auto_configure --builddirectory=x265-10bit -- \
		$(FLAGS) $(FLAGS_OTHERBIT)
	dh_auto_configure --builddirectory=x265-12bit -- \
		$(FLAGS) $(FLAGS_OTHERBIT) \
		-DMAIN12=ON
	dh_auto_configure -- \
		$(FLAGS) $(FLAGS_8BIT) \
		-DLIB_INSTALL_DIR=lib/$(DEB_HOST_MULTIARCH) \
		-DEXTRA_LIB="x265_main10.a;x265_main12.a" \
		-DLINKED_10BIT=ON \
		-DLINKED_12BIT=ON

execute_before_dh_auto_build-arch:
	dh_auto_build --builddirectory=x265-10bit
	dh_auto_build --builddirectory=x265-12bit
	mv x265-10bit/libx265.a x265-10bit/libx265_main10.a
	mv x265-12bit/libx265.a x265-12bit/libx265_main12.a

override_dh_auto_test-arch:
	# no tests

debian/arscript:
	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/' debian/arscript.in > debian/arscript

execute_after_dh_auto_install-arch: debian/arscript
	rm debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libx265.a
	ar -M <debian/arscript

# -indep bits

# no configure, test and install for indep
override_dh_auto_configure-indep override_dh_auto_test-indep override_dh_auto_install-indep:

override_dh_auto_build-indep:
	$(MAKE) -C doc/reST html

override_dh_installchangelogs:
	dh_installchangelogs doc/reST/releasenotes.rst

=== debian/watch ===
version=4
https://bitbucket.org/multicoreware/x265_git/downloads/ \
  x265_(\d.*).tar.gz
